function varargout = ODEparamSweepApp(varargin)
% ODEPARAMSWEEPAPP MATLAB code for ODEparamSweepApp.fig
%      ODEPARAMSWEEPAPP, by itself, creates a new ODEPARAMSWEEPAPP or raises the existing
%      singleton*.
%
%      H = ODEPARAMSWEEPAPP returns the handle to a new ODEPARAMSWEEPAPP or the handle to
%      the existing singleton*.
%
%      ODEPARAMSWEEPAPP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ODEPARAMSWEEPAPP.M with the given input arguments.
%
%      ODEPARAMSWEEPAPP('Property','Value',...) creates a new ODEPARAMSWEEPAPP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the App before ODEparamSweepApp_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ODEparamSweepApp_OpeningFcn via varargin.
%
%      *See UI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2013-2016 The MathWorks, Inc.

% Edit the above text to modify the response to help ODEparamSweepApp

% Last Modified by GUIDE v2.5 27-Oct-2014 21:34:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ODEparamSweepApp_OpeningFcn, ...
    'gui_OutputFcn',  @ODEparamSweepApp_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ODEparamSweepApp is made visible.
function ODEparamSweepApp_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ODEparamSweepApp (see VARARGIN)

% Choose default command line output for ODEparamSweepApp
handles.output = hObject;
title('  ');

% Force default colormap, otherwise we are stuck in the pre-14b land of jet.
colormap(handles.figure1,'default')


handles.serialHistory.UserData.useFileHistory = 1;  % Set to 0, unless on a workstation

lD = ODEparamSweeplimsDefaults;
if handles.checkbox2.Value==1
    thisVar='a';
else
    thisVar='n';
end

handles.hNumEdit.UserData = lD.h.defaultVal;
handles.maxNEdit.UserData = lD.(thisVar).defaultVal;

handles.hNumEdit.String = num2str(handles.hNumEdit.UserData);
handles.maxNEdit.String = num2str(handles.maxNEdit.UserData);

handles.serialHistory.UserData.percNow = cpuThrottleCheck;
handles.serialHistory.UserData.percLast = handles.serialHistory.UserData.percNow;

thisPool = getThisPool;
handles.parallelHistory.UserData.poolLast = thisPool;
handles.parallelHistory.UserData.poolNow = thisPool;

% Update handles structure
guidata(hObject, handles);

movegui(hObject, 'center');

%Update parallel information
resetKey(hObject, eventdata,handles,0,0,0);
updateParallelText(hObject, eventdata,handles);

function thisPool = getThisPool
p=gcp('nocreate');
if ~isempty(p)
    if isempty(p.Cluster)
        thisPool='';
    else
        thisPool=sprintf('%s_%i',p.Cluster.Profile,p.NumWorkers);
    end
else
    thisPool='';
end

% --- Outputs from this function are returned to the command line.
function varargout = ODEparamSweepApp_OutputFcn(~, ~, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in StartButton.
function StartButton_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to StartButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles = setEnableAll(handles,'off');

rtyps={'serialTime', 'parforTime', 'parfevalTime'};
for tt=1:length(rtyps)
    handles.(rtyps{tt}).FontWeight = 'normal';
end

guidata(hObject, handles);
drawnow

needsToLoop=1;

while needsToLoop
    try
        set(handles.checkbox3, 'enable', 'off');
        
        updateParallelText(hObject, eventdata, handles);
        
        [fh, th, isParallel, isLocal] = getRunOption(hObject, eventdata,handles);
        skipIt = 0;
        
        if isParallel
            try
                p = gcp;
                if isempty(p)
                    % This is necessary if preferences do not start a pool when needed
                    updateParallelText(hObject, eventdata, handles, 'starting a pool of workers');
                    p=parpool;
                end
                
                if isempty(p)
                    updateParallelText(hObject, eventdata, handles, 'Error: Unable to start a pool of workers');
                    skipIt = 1;
                    needsToLoop = 0;
                end
                
            catch
                disp(lasterr) %#ok<LERR>
                updateParallelText(hObject, eventdata, handles, 'Error: Unable to start a pool of workers, see session');
                skipIt = 1;
                needsToLoop = 0;
            end
        end
        
        if ~skipIt
            resetKey(hObject, eventdata, handles, 1, 1, 0);
            updateParallelText(hObject, eventdata, handles);
            
            % Note: you can't interrupt a parfor in any case, so there is no
            % mid-run halt ability.   Just close the UI.
            handles.StartButton.String = 'Running';
            guidata(hObject, handles);
            
            percLast = handles.serialHistory.UserData.percLast;
            
            drawnow
            
            [nVals,aVals,hVals,thisSfile,thisPfile] = getNAH(handles);
            
            try
                L = 1;
                showTruss = 0;
                
                t = tic;
                peakVals = fh(nVals,hVals,aVals,L,showTruss, handles.TopAxes); %#ok<NASGU
                et = toc(t);
                 
                updateParallelText(hObject, eventdata, handles);
                percNow = handles.serialHistory.UserData.percNow;
                 
                if true || (isParallel && ~isLocal) || (percLast == percNow)
                    if strcmp(th, 'serialTime')
                        thisFile = thisSfile;
                    else
                        thisFile = thisPfile;
                    end
                    
                    if ~exist(thisFile,'file') && handles.serialHistory.UserData.useFileHistory
                        save(thisFile,'peakVals','nVals','hVals','aVals','L')
                    end
                    
                    handles.(th).UserData = [handles.(th).UserData et];
                    handles.(th).FontWeight = 'bold';
                    
                    % augment and save current data here
                    dh = strrep(th, 'Time', 'Data');
                    tmpD = handles.(th).UserData; %#ok<NASGU>
                    eval([dh '=tmpD;']);
                    save(thisFile, dh, '-append');
                    
                    updateHistory(handles);
                    %drawnow
                    eMsg2 = [];
                else
                    eMsg2 = 'power mode changed, not recording run time';
                end
                
                if strcmp(th,'parfevalTime')
                    if handles.checkbox3.Value==1
                        handles.StartButton.String = 'uncheck now';
                        
                        set(handles.checkbox3, 'enable', 'on');
                        pause(2.5);
                        set(handles.checkbox3, 'enable', 'off');
                    end
                end
                
                updateParallelText(hObject, eventdata, handles, eMsg2);
                handles.StartButton.String = 'Start';
                
            catch
                eMsg=lasterr; %#ok<LERR>
                updateParallelText(hObject, eventdata, handles, eMsg);
                handles.StartButton.String = 'Start';
                handles = setEnableAll(handles,'on');
                needsToLoop = 0; %#ok<NASGU>
                drawnow
                guidata(hObject, handles);
                return
            end
            
            drawnow
            
            set(handles.TopAxes,'Visible','on')
            guidata(hObject, handles);
            
            if handles.checkbox3.Value==1 && strcmp(th,'parfevalTime');
                needsToLoop=1;
            else
                needsToLoop=0;
            end
        else  % skipIt
            handles = setEnableAll(handles,'on');
        end
    catch
        eMsg=lasterr; %#ok<LERR>
        updateParallelText(hObject, eventdata, handles, eMsg);
        handles.StartButton.String = 'Start';
        handles = setEnableAll(handles,'on');
        needsToLoop = 0; %#ok<NASGU>
        drawnow
        guidata(hObject, handles);
        return
    end
end

handles = setEnableAll(handles,'on');
guidata(hObject, handles);
drawnow

function handles = setEnableAll(handles,onOrOff)
set(handles.serialButton, 'enable', onOrOff);
set(handles.parforButton, 'enable', onOrOff);
set(handles.parfevalButton, 'enable', onOrOff);
set(handles.checkbox2, 'enable', onOrOff);
set(handles.maxNEdit, 'enable', onOrOff);
set(handles.hNumEdit, 'enable', onOrOff);
set(handles.StartButton, 'enable', onOrOff);
set(handles.checkbox3, 'enable', onOrOff);
set(handles.compareCodeButton, 'enable', onOrOff);

function maxNEdit_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to maxNEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxNEdit as text
%        str2double(get(hObject,'String')) returns contents of maxNEdit as a double

lD = ODEparamSweeplimsDefaults;

if handles.checkbox2.Value==1
    thisVar = 'a';
else
    thisVar = 'n';
end

val = str2double(handles.maxNEdit.String);
if isempty(val)
    val = NaN;
end

if ~isnan(val)
    val = max(val,lD.(thisVar).valLims(1));
    val = min(val,lD.(thisVar).valLims(2));
    val = round(val);
end

if ~isnan(val) && val~=handles.maxNEdit.UserData
    handles.maxNEdit.String = num2str(val);
    
    % Reset data if change is made
    resetKey(hObject, eventdata, handles, 0, 0, 0);
    updateParallelText(hObject, eventdata, handles);
else
    handles.maxNEdit.String = num2str(handles.maxNEdit.UserData);
end
handles.maxNEdit.UserData = str2double(handles.maxNEdit.String);
guidata(hObject, handles);
updateParallelText(hObject, eventdata,handles);


function hNumEdit_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to maxNEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

lD = ODEparamSweeplimsDefaults;

val = str2double(handles.hNumEdit.String);
if isempty(val)
    val = NaN;
end

if ~isnan(val)
    val = max(val,lD.h.valLims(1));
    val = min(val,lD.h.valLims(2));
    val = round(val);
end

if ~isnan(val) && val~=handles.hNumEdit.UserData
    handles.hNumEdit.String = num2str(val);
    
    % Reset data if change is made
    resetKey(hObject, eventdata, handles, 0, 0, 0);
    updateParallelText(hObject, eventdata, handles);
else
    handles.hNumEdit.String = num2str(handles.hNumEdit.UserData);
    
end
handles.hNumEdit.UserData = str2double(handles.hNumEdit.String);
guidata(hObject, handles);
updateParallelText(hObject, eventdata,handles);

function compareCodeButton_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to compareCodeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[fh,~,isParallel]=getRunOption(hObject, eventdata,handles);
if isParallel
    visdiff('paramSweepSerial.m', [char(fh) '.m']);
else
    %edit('paramSweepSerial.m');
    visdiff('paramSweepSerial.m', 'paramSweepParallel.m');
end

updateParallelText(hObject, eventdata,handles);

function resultsPanel_SelectionChangeFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to the selected object in resultsPanel
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

updateParallelText(hObject, eventdata,handles);

% Reset data during calculations, etc
function resetKey(hObject, ~, handles,leaveSerial,leaveParallel,leavePlot)

if ~leaveSerial
    handles.serialTime.String = '';
    handles.serialTime.UserData = [];
    handles.serialHistory.String = '';
end

if ~leaveParallel
    handles.parforTime.String = '';
    handles.parforTime.UserData = [];
    handles.parforHistory.String = '';
    
    handles.parfevalTime.String = '';
    handles.parfevalTime.UserData = [];
    handles.parfevalHistory.String = '';
end

handles.StartButton.String = 'Start';

guidata(hObject, handles);

if ~leavePlot
    cla(handles.TopAxes);
end
drawnow;


%Update display about matlabpool or other message
function updateParallelText(hObject, eventdata, handles,overrideMsg)

handles.serialHistory.UserData.percLast = handles.serialHistory.UserData.percNow;
handles.serialHistory.UserData.percNow = cpuThrottleCheck;

oldPool = handles.parallelHistory.UserData.poolNow;
handles.parallelHistory.UserData.poolNow = getThisPool;
handles.parallelHistory.UserData.poolLast = oldPool;

noOverRide = 1;

if nargin==4
    if ~isempty(overrideMsg)
        noOverRide = 0;
    end
end

if noOverRide
    p = gcp('nocreate');
    percStr = '';
    [~,~,isParallel, isLocal] = getRunOption(hObject, eventdata, handles);
    
    if handles.serialHistory.UserData.percNow ~= 0
        if ~isParallel || isLocal
            percStr = sprintf('client CPU clock at %d%%',handles.serialHistory.UserData.percNow);
        end
    end
    
    poolText='';
    if isParallel
        if ~isempty(p)
            poolText = sprintf('pool of %d workers (%s)', p.NumWorkers, p.Cluster.Profile);
        else
            poolText = 'pool of workers not started';
        end
        if ~isempty(percStr)
            percStr = [', ' percStr];
        end
    end
    
    newText = sprintf('%s%s', poolText, percStr);
    
    handles.matlabpoolText.ForegroundColor = [0 0 0];
else
    newText = overrideMsg;
    if strfind(lower(overrideMsg),'error')
        handles.matlabpoolText.ForegroundColor = [1 0 0];
    else
        handles.matlabpoolText.ForegroundColor = [0 0 0];
    end
end

handles.matlabpoolText.String = newText;

% Reset if the pool changed
if ~strcmp(handles.parallelHistory.UserData.poolNow, handles.parallelHistory.UserData.poolLast)
    if ~isempty(oldPool)
        resetKey(hObject, eventdata, handles, 0, 0, 1);
        guidata(hObject, handles);
    end
end

function parSerButtonGroup_SelectionChangeFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to the selected object in parSerButtonGroup
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

updateParallelText(hObject, eventdata, handles);

function [fh, th, isParallel, isLocal]=getRunOption(hObject, eventdata, handles)

pSG = get(handles.parSerButtonGroup);
pSGSO = get(pSG.SelectedObject);
runOption = pSGSO.String;

switch(runOption)
    case 'parfor'
        isParallel = 1;
        fh = @paramSweepParallel;
        th = 'parforTime';
        resetKey(hObject, eventdata,handles,1,1,1);
        
    case 'for (serial)'
        isParallel = 0;
        fh = @paramSweepSerial;
        th = 'serialTime';
        resetKey(hObject, eventdata,handles,1,1,1);
        
    case 'parfeval'
        isParallel = 1;
        fh = @paramSweepParfeval;
        th = 'parfevalTime';
        resetKey(hObject, eventdata,handles,1,1,1);
        
    otherwise
        error('unrecognized string from radio buttons');
end

guidata(hObject,handles);
drawnow

p = gcp('nocreate');

isLocal = false;
if ~isempty(p)
    if strcmp(p.Cluster.Profile,'local');
        isLocal = true;
    end
end


function checkbox2_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

lD = ODEparamSweeplimsDefaults;

valA0 = handles.maxNText.String;
valB0 = handles.maxNEdit.UserData;

if get(hObject,'Value')==1
    handles.maxNText.String = 'num cross sections';
    handles.maxNEdit.UserData = lD.a.defaultVal;
else
    handles.maxNText.String = 'num segment choice';
    handles.maxNEdit.UserData = lD.n.defaultVal;
end

handles.maxNEdit.String = num2str(handles.maxNEdit.UserData);

if ~strcmp(valA0, handles.maxNText.String) && (valB0 == handles.maxNEdit.UserData)
    resetKey(hObject, eventdata,handles,0,0,1);
end


function lD=ODEparamSweeplimsDefaults
%% NOTE: DO NOT CHANGE THESE: WILL BREAK ASSUMPTIONS OF LOAD/SAVE

lD.a.valLims = [3 100];
lD.a.range = [.2 .25];

lD.n.valLims = [2 100];
lD.n.range = [2 22];  % range(1) + valLime(2) needs to be <= range(2)

lD.h.valLims = [3 100];
lD.h.range = [.2 .5];

% defaults for actual values
lD.a.staticValue = mean(lD.a.range);
lD.n.staticValue = mean(lD.n.range);

%% Below this line can be changed as needed

% Defaults for number of values
lD.a.defaultVal = 10;  % Will be in lower UI box if handles.checkbox2==1
lD.n.defaultVal = 10;  % Will be in lower UI box if handles.checkbox2==0
lD.h.defaultVal = 10;
   

function [nVals,aVals,hVals,thisSfile,thisPfile]=getNAH(handles)

lD = ODEparamSweeplimsDefaults;

if handles.checkbox2.Value==0
    numN = str2double(handles.maxNEdit.String);
    nVals = lD.n.range(1)+(0:( numN-1));
    aVals = lD.a.staticValue;
    numA = 1;
else
    nVals = lD.n.staticValue;
    numA = str2double(handles.maxNEdit.String);
    aVals = linspace(lD.a.range(1),lD.a.range(2),numA);
    numN = 1;
end

numH = str2double(handles.hNumEdit.String);
hVals = linspace(lD.h.range(1),lD.h.range(2),numH);

% To actually use this feature
%percString = sprintf('cpu%03i_',handles.serialHistory.UserData.percLast);
% Or override with...
percString = 'cpuNaN_';


X = ver('MATLAB');
verStr = strrep(strtrim(strrep(strrep(X.Release,')',''),'(','')),' ','_');

aMode = handles.checkbox2.Value;
[~,thisHost] = system('hostname');  % Note: you might need to updsate this for Linux
thisSfile = sprintf('%s_%s_cs%i_a%03i_h%03i_n%03i_%sS.mat',verStr,deblank(thisHost),aMode,numA,numH,numN,percString);

percStringP = [];

p = gcp('nocreate');

thisPfile = [];
if ~isempty(p)
    if strcmp(p.Cluster.Profile,'local')
        percStringP=percString;
    end
    
    thisPfile = sprintf('%s_%s_cs%i_a%03i_h%03i_n%03i_%s%s_%i.mat',verStr,deblank(thisHost),aMode,numA,numH,numN,percStringP,p.Cluster.Profile,p.NumWorkers);
end

thisSfile = fullfile('.',thisSfile);
if ~isempty(thisPfile)
    thisPfile = fullfile('.',thisPfile);
end


function updateHistory(handles)

[~,~,~,thisSfile,thisPfile] = getNAH(handles);

if exist(thisSfile,'file');
    X = load(thisSfile);
else
    X = [];
end

if exist(thisPfile,'file');
    X2 = load(thisPfile);
else
    X2 = [];
end

lst = {'serialTime','parforTime','parfevalTime'};

% merge data from both history files
if isempty(X)
    X = X2;
else
    if ~isempty(X2)
        for ll=2:length(lst)
            xlst = lst{ll};
            xlst = strrep(xlst,'Time','Data');
            if isfield(X2, xlst)
                X.(xlst) = X2.(xlst);
            end
        end
    end
end

% Fill in UI data from merged...
for xx=1:length(lst)
    if isempty(handles.(lst{xx}).UserData)
        dLst=strrep(lst{xx},'Time','Data');
        if isfield(X,dLst)
            handles.(lst{xx}).UserData = X.(dLst);
        end
    end
end

% Get reference data for speed-up
if ~isempty(handles.serialTime.UserData)
    serialData = handles.serialTime.UserData;
    speedRef = mean(serialData);
else
    serialData = [];
    speedRef = [];
end

% Fill in text in UI
for xx=1:length(lst)
    tth = lst{xx};
    
    tthH = strrep(tth,'Time','History');
    
    thisLng = length(handles.(tth).UserData);
    if thisLng>0
        lclT = handles.(tth).UserData(end);
        if ~isempty(serialData) && ~strcmp(tth,'serialTime');
            lastAvgTxt = sprintf('%0.1fs %1.1fx',lclT,serialData(end)/lclT);
        else
            lastAvgTxt = sprintf('%0.1fs',lclT);
        end
        
        handles.(tth).String = sprintf('%s',lastAvgTxt);
        thisAvg = mean(handles.(tth).UserData);
        if ~isempty(speedRef) && ~strcmp(tth,'serialTime');
            handles.(tthH).String = sprintf('%0.1fs %1.1fx (%i)',thisAvg,speedRef/thisAvg,thisLng);
        else
            handles.(tthH).String = sprintf('%0.1fs \t\t (%i)',thisAvg,thisLng);
        end
    end
end

% --- Executes during object creation, after setting all properties.
function maxNEdit_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to maxNEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function hNumEdit_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to maxNEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function checkbox3_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% This is meant to be empty
