%% batch processing of a function
% Copyright 2013-2016 The MathWorks, Inc.

%% Close any open pool of workers 
delete(gcp('nocreate'));

%% Submit job.  
% change profile from 'local' and adjust pool size if a cluster is available
nVals=12;
hVals=linspace(.2,.5,20);
aVals=linspace(.2,.25,20);

myProfile='local'; numWorkers=3;         % I have a 4-core laptop
%myProfile='R2016a_128'; numWorkers=127; % Put the name of your cluster profile here

job1=batch('paramSweepParallel',5,{nVals,hVals,aVals,1,0,[]},'Profile',myProfile,'Pool',numWorkers);  

%% Check status
job1.State
wait(job1); %optional

%% Plot data when job is finished
jobOut=fetchOutputs(job1);

close all;  
visualizeParamSweep(jobOut{3},jobOut{4},jobOut{5},jobOut{1},gca);
mainComputationTime=jobOut{2} %#ok<NOPTS>